/*
 * LCDW[(SC1602) 4bit[hCu[  Version 1.00
 * File:        lcd.c
 * Target:      PIC18F14K50 48Mhz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2013/09/29 15:00
 *
*/

#ifndef LCD_H
#define	LCD_H

//  MAhXݒ

#define LCD_E       PORTCbits.RC3
#define LCD_RS      PORTCbits.RC2
#define LCD_E_MASK  0b0001000
#define LCD_RS_MASK 0b0000100
#define LCD_ADS     PORTC

#define LCD_CMAX    16 //   t
#define LCD_RMAX     2 //   t\s

#define LCD_CLEAR   0b00000001
#define LCD_CURHOME 0b00000010
#define LCD_ENTRYM  0b00000100
    #define LCD_INC       0b10
    #define LCD_DEC       0b00
    #define LCD_SHIFT      0b1
    #define LCD_NONSHIFT   0b0
#define LCD_DISPM   0b00001000
    #define LCD_DISPON   0b100
    #define LCD_DISPOFF  0b000
    #define LCD_CURON     0b10
    #define LCD_CUROFF    0b00
    #define LCD_BLINKON    0b1
    #define LCD_BLINKOFF   0x0
#define LCD_SHIFTM  0b00010000
#define LCD_FUNCM   0b00100000
    #define LCD_8BIT   0b10000
    #define LCD_4BIT   0b00000
#define LCD_CGADS   0b01000000
#define LCD_DDADS   0b10000000

void lcd_init(void); //  LCDt
void lcd_disp(const unsigned char* buf); //  z[ʒu當tɕ\ \nɂ镡sѐ܂Ԃ\T|[g
void lcd_clear(); //  tNA
void lcd_puts(const char* buf); //  JgAhXɕ
void lcd_putc(char buf); //  JgAhX1
void lcd_en(unsigned char d); //  t\ݒ(uNAJ[\)
void lcd_ddramxy(unsigned char x,unsigned char y); //  \pAhXݒ ƍsŎw
void lcd_ddram(unsigned char ads); //  \pAhXݒ
void lcd_cgram(unsigned char ads,unsigned char* buf); //  [U[`LN^ݒ
void lcd_out4(unsigned char data); //  4bito
void lcd_out8(unsigned char data); //  8bit4bitɕďo

#endif	/* LCD_H */

