/*
 * RTC8564 RTCCu Version 1.00
 * File:        rtc.c
 * Target:      PIC18F14K50 48MHz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2013/09/29 15:00
 *
 * AdቺtOoARTCǂݏAC^[o^C}[On/Off
*/

#ifndef RTC_H
#define	RTC_H

//       RTCWX^̒`

#define RTC8564_SADS    0b10100010 //   X[uAhX
#define RTC_CTL1    0
#define RTC_CTL2    1
#define RTC_SEC     2
#define RTC_MIN     3
#define RTC_HOUR    4
#define RTC_DAY     5
#define RTC_WEEK    6
#define RTC_MONTH   7
#define RTC_YEAR    8
#define RTC_AMIN    9
#define RTC_AHOUR   0xa
#define RTC_ADAY    0xb
#define RTC_AWEEK   0xc
#define RTC_CLOCK   0xd
#define RTC_TIMERCTL   0xe
#define RTC_TIMER   0xf


struct RTC_DATE {
    unsigned char sec;
    unsigned char min;
    unsigned char hour;
    unsigned char day;
    unsigned char week;
    unsigned char month;
    unsigned char year;
};

signed char rtc_init(void); //  RTC
void rtc_sput(unsigned char* buf,struct RTC_DATE* d); //  \
void rtc_date_sput(unsigned char* buf,struct RTC_DATE* d); //  t\
void rtc_time_sput(unsigned char* buf,struct RTC_DATE* d); //  \
signed char rtc_start(void); //  RTCJEgJn
signed char rtc_stop(void); //  RTCJEg~
signed char rtc_write(struct RTC_DATE* d); //  ݒ
signed char rtc_read(struct RTC_DATE* d); //  ǂݏo
signed char rtc_vl_chk(void); //  VLrbg`FbN  1:Kv 0:sv
void rtc_timer_on(void); //  1b^C}[Jn
void rtc_timer_off(void); //  1b^C}[~

#endif  //  RTC_H

