/*
 * RTC8564 LCD v@Version 1.10
 * File:        rtc4c.c
 * Target:      PIC18F14K50 48MHz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2013/10/08 20:00
 *
 * C@\tvBj\щ[N⌎̓ɍ킹ēC\( 30,29ɑΉ)
 * RTCobeobNAbvĂꍇ́AdRTC̏͂ȂB(RTC8564VLrbgQ)
 * IOSP[qƋpłIOCA3ɂԕω荞݂1bԊuŎgp
 * IOSP[qƋpłRA0ARA1SW0ASW1̃XCb`Ɏgp
 * RC1͎gpĂȂ(IɃAiO͂ƂĎgp\)
 * g
 *   SW0ƎC[hɂȂ
 *   C[hłSW1ƒlCNgASW0Ǝ̍ڂ̏C
 *   Cڂ<-Ŏ鍶̒lłBC[hŕb\ĂƂSW0ƎRTCɃZbgv\ƂȂB
 *              e[q̐ڑ
 *              RA0 in      :SW0
 *              RA1 in      :SW1
 *              IOCA3 in    :RTCC^[o荞(1bԊu)
 *              RC0 out     :LED0
 *              RC2 out     :LCD RS
 *              RC3 out     :LCD E
 *              RC4-RC7 out :LCD DB4-DB7
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <p18f14k50.h>
#include <plib\delays.h>
#include <plib\i2c.h>
#include "rtc.h"
#include "lcd.h"
#include "sw.h"

#pragma config  FOSC = HS,CPUDIV = NOCLKDIV,PLLEN=ON,WDTEN=OFF,LVP=OFF,MCLRE=OFF

#define LED0 PORTCbits.RC0

char buf[34];
unsigned char RE_PORTA;

unsigned char week(unsigned short y,unsigned char m,unsigned char d);
unsigned char leap_chk(unsigned short year);
void uchar_in(unsigned char* v,unsigned char min,unsigned char max,unsigned char c,unsigned char y);
unsigned char bcd2bin(unsigned char v);
unsigned char bin2bcd(unsigned char v);
void rtc_sput2(unsigned char* buf,struct RTC_DATE* d);
void rtc_set(struct RTC_DATE* rp);
void  interrupt isr(void);

const char* week_s[]={ "Sun","Mon","Tue","Wed","Thu","Fri","Sat",0 };

void main(void) {
    ANSEL=0;
    ANSELH=0;
    SLRCON=0;
    INTCON2=0b10000001; // vAbvȂ ԕω荞݂Dxɂ
    TRISA=0b00000000;
    TRISB=0b11110000;
    TRISC=0b00000000;
    PORTC=0;
    IOCAbits.IOCA0=1;   //  RA0
    IOCAbits.IOCA1=1;   //  RA1
    IOCAbits.IOCA3=1;   //  RA3
    lcd_init();
    OpenI2C(MASTER,SLEW_ON);    // }X^[
    SSPADD=230;
    LED0=0;

    if(rtc_vl_chk()){
        rtc_init();
        rtc_start();
    }
    RE_PORTA=PORTA;
    INTCONbits.RABIF=0;
    INTCONbits.RABIE=1; //  RA3?5,RB4?7̏ԕω荞݂
    INTCONbits.GIE=1;

    rtc_timer_on(); //  1b̃C^[o^C}[N

    while(1){
    }
}

//  tj擾

unsigned char week(unsigned short y,unsigned char m,unsigned char d){
    if(m <= 2){
	--y;
        m += 12;
    }
    unsigned short long w=d;
    w= w + ( ( 8+ 13*m)/5 );
    w= w + (y + (y / 4) - (y/100) + (y/400) );
    return w % 7;
}

// 邤N 1ԂƂ邤N

unsigned char leap_chk(unsigned short year){
    unsigned char l;
    signed char r4= ((unsigned short)year % 4);
    signed char r100 = ((unsigned short)year % 100);
    signed char r400 = ((unsigned short)year % 400);
    if(r4==0){
        if(r100==0){
            if(r400==0)
               l=1;
             else
               l=0;
        }else
             l=1;
     }else
          l=0;
    return l;
}

//  ^NgXCb`ɂ1byte(wELCD\t)
//   c:LCDʒu y:LCDsʒu
//  SW1:lup  SW0:I

void uchar_in(unsigned char* v,unsigned char min,unsigned char max,unsigned char c,unsigned char y){
    unsigned char swv,swv_trg;
    for(;;){
        lcd_ddramxy( c,y);
        sprintf(buf,"%2.2i",(int)*v);
        lcd_puts(buf);
        for(;;){
            sw_trg_in(&swv,&swv_trg);
            if( (swv & SW1_MASK)==0 ){ // SW0Ă̂ŃCNg
                if(*v>=max)
                    *v=min;
                else
                    (*v)++;
                Delay10KTCYx(200);

                break;
            }
            if( (swv_trg & SW0_MASK) && (swv & SW0_MASK)==0 ){ // SW1ꂽu
                do{
                    sw_trg_in(&swv,&swv_trg);
                }while((swv_trg & SW0_MASK) && (swv & SW0_MASK)); // SW1ꂽu
                return;
            }
        }
    }
}

//  BCDoCiɕϊ

unsigned char bcd2bin(unsigned char v){
    unsigned char d1=(v>>4);
    unsigned char d2=(v & 0xf);
    if(d2>9){
       ++d1;
       d2 -= 10;
    }
    return d1*10 + d2;
}

//  oCiBCDɕϊ

unsigned char bin2bcd(unsigned char v){
    unsigned d1=(v % 10);
    unsigned d2=(v / 10)<<4;
    return  d2+d1 ;
}

//  \

void rtc_sput2(unsigned char* buf,struct RTC_DATE* d){
    sprintf(buf,"20%2.2x/%2.2x/%2.2x  %s\n%.2x:%.2x:%.2x",d->year,d->month,d->day,week_s[d->week],d->hour,d->min,d->sec);
}

//  tC
//  SW1:lup  SW0:̏C

void rtc_set(struct RTC_DATE* rp){
    unsigned char sel=0;   // Cʒu
    unsigned char v;
    unsigned char leap;   //  邤N̂Ƃ1Zbg
    unsigned char dmax;  //  ̍ől
    unsigned char w;    //  j
    unsigned char e=0;  //  I

    for(;;){
        rtc_sput2(buf,rp);
        lcd_disp(buf);
        switch(sel){
        case 0: //  N
            lcd_ddramxy( 4,0);
            lcd_putc(0x7f); //  <-

            v=bcd2bin(rp->year);
            uchar_in(&v,0,99,2,0);
            rp->year=bin2bcd(v);
            leap=leap_chk(v+2000);

            lcd_ddramxy( 4,0);
            lcd_putc('/');

            w=week( bcd2bin(rp->year)+2000 , bcd2bin(rp->month) , bcd2bin(rp->day));
            rp->week=w;

            ++sel;
            break;
        case 1: //  
            lcd_ddramxy( 7,0);
            lcd_putc(0x7f); //  <-

            v=bcd2bin(rp->month);
            uchar_in(&v,1,12,5,0);
            rp->month=bin2bcd(v);
            switch(v){
                case 1:
                case 3:
                case 5:
                case 7:
                case 8:
                case 9:
                case 10:
                case 12:
                    dmax=31; break;
                case  2:
                    dmax=28+leap; break;
                default:
                     dmax=30; break;
            }
            lcd_ddramxy( 7,0);
            lcd_putc('/');
            w=week( bcd2bin(rp->year)+2000 , bcd2bin(rp->month) , bcd2bin(rp->day));
            rp->week=w;

            ++sel;
            break;
        case 2: //  
            lcd_ddramxy(10,0);
            lcd_putc(0x7f); //  <-

            v=bcd2bin(rp->day);
            uchar_in(&v,1,dmax,8,0);
            rp->day=bin2bcd(v);
            w=week( bcd2bin(rp->year)+2000 , bcd2bin(rp->month) , bcd2bin(rp->day));
            rp->week=w;
            lcd_ddramxy( 10,0);
            lcd_putc('/');
            ++sel;
            break;
        case 3: //  
            lcd_ddramxy(2,1);
            lcd_putc(0x7f); //  <-

            v=bcd2bin(rp->hour);
            uchar_in(&v,0,23,0,1);
            rp->hour=bin2bcd(v);
            lcd_ddramxy(2,1);
            lcd_putc(':');
            ++sel;
            break;
        case 4: //  
            lcd_ddramxy(5,1);
            lcd_putc(0x7f); //  <-

            v=bcd2bin(rp->min);
            uchar_in(&v,0,59,3,1);
            rp->min=bin2bcd(v);
            lcd_ddramxy(5,1);
            lcd_putc('/');
            ++sel;
            break;
        case 5: //  b
            lcd_ddramxy(8,1);
            lcd_putc(0x7f); //  <-

            v=bcd2bin(rp->sec);
            uchar_in(&v,0,59,6,1);
            rp->sec=bin2bcd(v);
            lcd_ddramxy(8,1);
            lcd_putc(' ');
            ++sel;
            break;
        case 6: //  I
            return;

        }
    }
}


//  1bů荞ݏ[`

void  interrupt isr(void){
    char buf[34];
    struct RTC_DATE rtc;
    unsigned char swv,swv_trg;

    unsigned char now=PORTA;
    unsigned char re=RE_PORTA;
    RE_PORTA=now;
    INTCONbits.RABIF=0;
    if( ((re ^ now) & 0b00001000) ) //  IOCA3ω(IOCA0IOCA1͖)
        if(now & 0b00001000)    //  オGbWȂ̂Ŗ߂
            return;
    rtc_read(&rtc);
    rtc_sput2(buf,&rtc);
    lcd_disp(buf);

    sw_trg_in(&swv,&swv_trg);
    if( (swv_trg & SW0_MASK) && (swv & SW0_MASK)==0 ){ // SW0ꂽu
        INTCONbits.RABIE=0;
        rtc_timer_off();
        do{
            sw_trg_in(&swv,&swv_trg);
        }while((swv_trg & SW0_MASK) && (swv & SW0_MASK)); // SW0ꂽu
        rtc_set(&rtc);
        rtc_write(&rtc);
        rtc_timer_on();
        RE_PORTA=PORTA;
        INTCONbits.RABIE=1;
        return;
    }else
        LED0 = ~LED0;
}
